/************************************************************************************/
/*  Program name CAPFAEXT_CAT_BOOK.sql                                              */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_CAT_BOOK';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_CAT_BOOK.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_CATEGORY_BOOKS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Category_ID||CHR(9)||
				C1.Book_Type_Code||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Asset_Clearing_Acct||CHR(9)||
				C1.Asset_Cost_Acct||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Attribute_Category_Code||CHR(9)||
				C1.CIP_Clearing_Acct||CHR(9)||
				C1.CIP_Cost_Acct||CHR(9)||
				C1.Deprn_Expense_Acct||CHR(9)||
				C1.Deprn_Reserve_Acct||CHR(9)||
				C1.Reval_Amortization_Acct||CHR(9)||
				C1.Reval_Reserve_Acct||CHR(9)||
					C1.Asset_Cost_Account_CCID||CHR(9)||
					C1.Asset_Clearing_Account_CCID||CHR(9)||
					C1.WIP_Cost_Account_CCID||CHR(9)||
					C1.WIP_Clearing_Account_CCID||CHR(9)||
					C1.Reserve_Account_CCID||CHR(9)||
					C1.Reval_Amort_Account_CCID||CHR(9)||
					C1.Reval_Reserve_Account_CCID||CHR(9)||
				C1.Life_Extension_Ceiling||CHR(9)||
				C1.Life_Extension_Factor||CHR(9)||
				C1.Percent_Salvage_Value||CHR(9)||
				C1.Global_Attribute1||CHR(9)||
				C1.Global_Attribute2||CHR(9)||
				C1.Global_Attribute3||CHR(9)||
				C1.Global_Attribute4||CHR(9)||
				C1.Global_Attribute5||CHR(9)||
				C1.Global_Attribute6||CHR(9)||
				C1.Global_Attribute7||CHR(9)||
				C1.Global_Attribute8||CHR(9)||
				C1.Global_Attribute9||CHR(9)||
				C1.Global_Attribute10||CHR(9)||
				C1.Global_Attribute11||CHR(9)||
				C1.Global_Attribute12||CHR(9)||
				C1.Global_Attribute13||CHR(9)||
				C1.Global_Attribute14||CHR(9)||
				C1.Global_Attribute15||CHR(9)||
				C1.Global_Attribute16||CHR(9)||
				C1.Global_Attribute17||CHR(9)||
				C1.Global_Attribute18||CHR(9)||
				C1.Global_Attribute19||CHR(9)||
				C1.Global_Attribute20||CHR(9)||
				C1.Global_Attribute_Category||CHR(9)||
				C1.Default_Group_Asset_ID||CHR(9)||
				C1.Bonus_Deprn_Expense_Acct||CHR(9)||
				C1.Bonus_Deprn_Reserve_Acct||CHR(9)||
					C1.Bonus_Reserve_Acct_CCID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Asset_Cost_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Asset_Clearing_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.WIP_Cost_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.WIP_Clearing_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Reserve_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Reval_Amort_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Reval_Reserve_Account_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Bonus_Reserve_Acct_CCID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/